﻿Imports System.Data.Common
Imports LogManager
' ---------------------------------------------------------------------------------------------------------
' Implementem les funcions d'accés a dades de diverses taules i vistes
'----------------------------------------------------------------------------------------------------------

Public Class Consultes
    Inherits Taula

    Public Function EsEmpleat(ByVal idUsuari As String) As DataTable
        Try

            Dim con As DbConnection = Me.getDbConnection()

            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT count(idUsuari) FROM Empleat WHERE idUsuari=@idUsuari"
            command.Connection = con

            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.Value = idUsuari
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)



            EsEmpleat = New DataTable(Me.getNomTaula())
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(EsEmpleat)
            adapter.Dispose()
            command.Dispose()
            con.Dispose()
        Catch ex As Exception
            EsEmpleat = Nothing
        End Try
    End Function
    Public Function getTotsAgenda() As DataTable
        Try

            Dim con As DbConnection = Me.getDbConnection()

            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM " & Me.getNomTaula & " ORDER BY Data, Cognom1, Cognom2, Nom"
            command.Connection = con
            getTotsAgenda = New DataTable(Me.getNomTaula())
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(getTotsAgenda)
            adapter.Dispose()
            command.Dispose()
            con.Dispose()
        Catch ex As Exception
            getTotsAgenda = Nothing
        End Try
    End Function

    Public Function getAgendaClient(ByVal idUsuari As String) As DataTable
        Try

            Dim con As DbConnection = Me.getDbConnection()

            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM " & Me.getNomTaula & " WHERE idUsuari=@idUsuari ORDER BY Data"
            command.Connection = con

            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.Value = idUsuari
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)



            getAgendaClient = New DataTable(Me.getNomTaula())
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(getAgendaClient)
            adapter.Dispose()
            command.Dispose()
            con.Dispose()
        Catch ex As Exception
            getAgendaClient = Nothing
        End Try
    End Function


    Public Function cercaClients(ByVal nom As String, ByVal cognom1 As String, ByVal cognom2 As String, ByVal idclient As String) As DataTable
        Try
            Dim con As DbConnection = Me.getDbConnection()

            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM vClients "
            command.Connection = con

            If nom <> "" Or cognom1 <> "" Or cognom2 <> "" Or idclient <> "" Then
                command.CommandText = command.CommandText & " WHERE "
            End If
            Dim addAnd As Boolean = False
            If nom <> "" Then
                Dim param1 As DbParameter = Me.getDbParameter
                param1.ParameterName = "Nom"
                param1.Value = nom
                param1.DbType = DbType.String
                command.CommandText = command.CommandText & "Nom like @Nom"
                addAnd = True
                command.Parameters.Add(param1)
            End If

            If cognom1 <> "" Then
                Dim param1 As DbParameter = Me.getDbParameter
                param1.ParameterName = "Cognom1"
                param1.Value = cognom1
                param1.DbType = DbType.String
                If addAnd = True Then
                    command.CommandText = command.CommandText & " AND "
                End If
                command.CommandText = command.CommandText & "Cognom1 like @Cognom1"
                addAnd = True
                command.Parameters.Add(param1)
            End If

            If cognom2 <> "" Then
                Dim param1 As DbParameter = Me.getDbParameter
                param1.ParameterName = "Cognom2"
                param1.Value = cognom2
                param1.DbType = DbType.String
                If addAnd = True Then
                    command.CommandText = command.CommandText & " AND "
                End If
                command.CommandText = command.CommandText & "Cognom2 like @Cognom2"
                addAnd = True
                command.Parameters.Add(param1)
            End If

            If idclient <> "" Then
                Dim param1 As DbParameter = Me.getDbParameter
                param1.ParameterName = "idUsuari"
                param1.Value = cognom1
                param1.DbType = DbType.String
                If addAnd = True Then
                    command.CommandText = command.CommandText & " AND "
                End If
                command.CommandText = command.CommandText & "idUsuari like @idUsuari"
                addAnd = True
                command.Parameters.Add(param1)
            End If

            command.CommandText = command.CommandText & " ORDER BY Cognom1, Cognom2, Nom"

            cercaClients = New DataTable("vClients")
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(cercaClients)
            adapter.Dispose()
            command.Dispose()
            con.Dispose()
        Catch ex As Exception
            cercaClients = Nothing
        End Try
    End Function
    Function CercaUsuari(ByVal idUsuari As String) As DataTable
        Try
            Dim con As DbConnection = Me.getDbConnection()
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM Usuaris WHERE idUsuari=@idUsuari"
            command.Connection = con


            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.Value = idUsuari
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)


            CercaUsuari = New DataTable("Usuaris")
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(CercaUsuari)
            adapter.Dispose()
            command.Dispose()
            ' trans.Commit()
            ' con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            CercaUsuari = Nothing
        End Try



    End Function
    Function CercaClient(ByVal idUsuari As String) As DataTable
        Try
            Dim con As DbConnection = Me.getDbConnection()
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM Client E,Usuaris U WHERE E.idUsuari=U.idUsuari AND E.idUsuari=@idUsuari"
            command.Connection = con


            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.Value = idUsuari
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)


            CercaClient = New DataTable("Client")
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(CercaClient)
            adapter.Dispose()
            command.Dispose()
            ' trans.Commit()
            ' con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            CercaClient = Nothing
        End Try



    End Function
    Function CercaEmpl(ByVal idUsuari As String) As DataTable
        Try
            Dim con As DbConnection = Me.getDbConnection()
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM Empleat E,Usuaris U WHERE E.idUsuari=U.idUsuari AND E.idUsuari=@idUsuari"
            command.Connection = con


            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.Value = idUsuari
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)


            CercaEmpl = New DataTable("Client")
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(CercaEmpl)
            adapter.Dispose()
            command.Dispose()
            ' trans.Commit()
            ' con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            CercaEmpl = Nothing
        End Try



    End Function



    Protected Overrides Function getNomTaula() As String
        getNomTaula = "ConsultesAgenda"
    End Function
End Class