﻿Imports System.Data.Common
Imports LogManager

' ---------------------------------------------------------------------------------------------------------
' Implementem les funcions d'accés a dades a la taula Activitat
'----------------------------------------------------------------------------------------------------------
Public Class TaulaActivitat
    Inherits Taula

    Public Function getTotesActivitatsOrdenadesPerDescripcio() As DataTable
        Try
            Dim dt As New DataTable(Me.getNomTaula())
            Dim con As DbConnection = Me.getDbConnection()
            
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM " & Me.getNomTaula & " ORDER BY Descripcio"
            command.Connection = con
            getTotesActivitatsOrdenadesPerDescripcio = New DataTable(Me.getNomTaula())

            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(getTotesActivitatsOrdenadesPerDescripcio)
            adapter.Dispose()
            command.Dispose()
           
            con.Dispose()
        Catch ex As Exception
            getTotesActivitatsOrdenadesPerDescripcio = Nothing
        End Try
    End Function

    Public Function getActivitatsOrdenadesDisponibles() As DataTable
        Try
            Dim dt As New DataTable(Me.getNomTaula())
            Dim con As DbConnection = Me.getDbConnection()

            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM " & Me.getNomTaula & " WHERE NumPlaces>0 AND DATA>=GETDATE() ORDER BY Data, Hora"
            command.Connection = con
            getActivitatsOrdenadesDisponibles = New DataTable(Me.getNomTaula())

            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(getActivitatsOrdenadesDisponibles)
            adapter.Dispose()
            command.Dispose()

            con.Dispose()
        Catch ex As Exception
            getActivitatsOrdenadesDisponibles = Nothing
        End Try
    End Function
    Public Function getActivitat(ByVal idActivitat) As DataTable
        Try
            Dim dt As New DataTable(Me.getNomTaula())
            Dim con As DbConnection = Me.getDbConnection()

            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM " & Me.getNomTaula & " WHERE idActivitat=@idActivitat"
            command.Connection = con
            getActivitat = New DataTable(Me.getNomTaula())

            Dim _idActivitat As DbParameter = Me.getDbParameter()
            _idActivitat.ParameterName = "idActivitat"
            _idActivitat.Value = idActivitat
            _idActivitat.DbType = DbType.Int32
            command.Parameters.Add(_idActivitat)

            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(getActivitat)
            adapter.Dispose()
            command.Dispose()

            con.Dispose()
        Catch ex As Exception
            getActivitat = Nothing
        End Try
    End Function
    Public Function addActivitat(ByVal Descripcio As String, ByVal NumPlaces As Integer, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "INSERT INTO " & Me.getNomTaula & " (Descripcio, NumPlaces, Data, Hora) VALUES (@Descripcio, @NumPlaces, @Data, @Hora)"
            command.Connection = con
            command.Transaction = trans

            Dim _descripcio As DbParameter = Me.getDbParameter()
            _descripcio.ParameterName = "Descripcio"
            _descripcio.Value = Descripcio
            _descripcio.DbType = DbType.String
            _descripcio.Size = 150
            command.Parameters.Add(_descripcio)

            Dim _numPlaces As DbParameter = Me.getDbParameter()
            _numPlaces.ParameterName = "NumPlaces"
            _numPlaces.Value = NumPlaces
            _numPlaces.DbType = DbType.Int32
            command.Parameters.Add(_numPlaces)

            Dim _Data As DbParameter = Me.getDbParameter()
            _Data.ParameterName = "Data"
            _Data.Value = Date.Parse(Data)
            _Data.DbType = DbType.Date
            command.Parameters.Add(_Data)

            Dim _Hora As DbParameter = Me.getDbParameter()
            _Hora.ParameterName = "Hora"
            _Hora.Value = Convert.ToDateTime(Convert.ToString(Hora))
            _Hora.DbType = DbType.Time
            command.Parameters.Add(_Hora)


            command.Prepare()

            addActivitat = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            'MsgBox("Excepció: " & ex.Message)
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            addActivitat = False
        End Try
    End Function


    Public Function deleteActivitat(ByVal idActividad As Integer) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE idActivitat=@idActivitat"
            command.Connection = con
            command.Transaction = trans

            Dim _idActivitat As DbParameter = Me.getDbParameter()
            _idActivitat.ParameterName = "idActivitat"
            _idActivitat.Value = idActividad
            _idActivitat.DbType = DbType.Int32
            command.Parameters.Add(_idActivitat)

            command.Prepare()

            deleteActivitat = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deleteActivitat = False
        End Try
    End Function

    Public Function updateActivitat(ByVal idActividad As Integer, ByVal Descripcio As String, ByVal NumPlaces As Integer, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "UPDATE " & Me.getNomTaula & " SET Descripcio=@Descripcio, NumPlaces=@NumPlaces WHERE idActivitat=@idActivitat"
            command.Connection = con
            command.Transaction = trans

            Dim _descripcio As DbParameter = Me.getDbParameter()
            _descripcio.ParameterName = "Descripcio"
            _descripcio.Value = Descripcio
            _descripcio.DbType = DbType.String
            _descripcio.Size = 150
            command.Parameters.Add(_descripcio)

            Dim _numPlaces As DbParameter = Me.getDbParameter()
            _numPlaces.ParameterName = "NumPlaces"
            _numPlaces.Value = NumPlaces
            _numPlaces.DbType = DbType.Int32
            command.Parameters.Add(_numPlaces)

            Dim _idActivitat As DbParameter = Me.getDbParameter()
            _idActivitat.ParameterName = "idActivitat"
            _idActivitat.Value = idActividad
            _idActivitat.DbType = DbType.Int32
            command.Parameters.Add(_idActivitat)

            Dim _Data As DbParameter = Me.getDbParameter()
            _Data.ParameterName = "Data"
            _Data.Value = Data
            _Data.DbType = DbType.Date
            command.Parameters.Add(_Data)

            Dim _Hora As DbParameter = Me.getDbParameter()
            _Hora.ParameterName = "Hora"
            _Hora.Value = Hora
            _Hora.DbType = DbType.Time
            command.Parameters.Add(_Hora)


            command.Prepare()

            updateActivitat = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            updateActivitat = False
        End Try
    End Function
    Public Function updateActPlaces(ByVal idActividad As Integer, ByVal NumPlaces As Integer) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "UPDATE " & Me.getNomTaula & " SET NumPlaces=@NumPlaces WHERE idActivitat=@idActivitat"
            command.Connection = con
            command.Transaction = trans

            Dim _numPlaces As DbParameter = Me.getDbParameter()
            _numPlaces.ParameterName = "NumPlaces"
            _numPlaces.Value = NumPlaces
            _numPlaces.DbType = DbType.Int32
            command.Parameters.Add(_numPlaces)

            Dim _idActivitat As DbParameter = Me.getDbParameter()
            _idActivitat.ParameterName = "idActivitat"
            _idActivitat.Value = idActividad
            _idActivitat.DbType = DbType.Int32
            command.Parameters.Add(_idActivitat)

            command.Prepare()

            updateActPlaces = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            updateActPlaces = False
        End Try

    End Function

    Protected Overrides Function getNomTaula() As String
        getNomTaula = "Activitat"
    End Function


End Class
