﻿Imports System.Data.Common
Imports LogManager
' ---------------------------------------------------------------------------------------------------------
' Implementem les funcions d'accés a dades a la taula Client
'----------------------------------------------------------------------------------------------------------

Public Class TaulaClient
    Inherits Taula



    Public Function addClient(ByVal idUsuari As String, ByVal NumHabitacio As Integer, ByVal Data As Date) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "INSERT INTO " & Me.getNomTaula & " (idUsuari, NumHabitacio, Data) VALUES (@idUsuari, @NumHabitacio, @Data)"
            command.Connection = con
            command.Transaction = trans

            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.Value = idUsuari
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)

            Dim _NumHabitacio As DbParameter = Me.getDbParameter()
            _NumHabitacio.ParameterName = "NumHabitacio"
            _NumHabitacio.Value = NumHabitacio
            _NumHabitacio.DbType = DbType.Int32
            command.Parameters.Add(_NumHabitacio)

            Dim _Data As DbParameter = Me.getDbParameter()
            _Data.ParameterName = "Data"
            _Data.Value = Data
            _Data.DbType = DbType.Date
            command.Parameters.Add(_Data)

            command.Prepare()

            addClient = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            addClient = False
        End Try
    End Function

    Public Function updateClient(ByVal idUsuari As String, ByVal NumHabitacio As Integer) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "UPDATE Client SET NumHabitacio=@NumHabitacio WHERE idUsuari=@idUsuari"
            command.Connection = con
            command.Transaction = trans

            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.Value = idUsuari
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)

            Dim _NumHabitacio As DbParameter = Me.getDbParameter()
            _NumHabitacio.ParameterName = "NumHabitacio"
            _NumHabitacio.Value = NumHabitacio
            _NumHabitacio.DbType = DbType.Int32
            command.Parameters.Add(_NumHabitacio)

            command.Prepare()

            updateClient = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            updateClient = False
        End Try
    End Function

    Public Function deleteClient(ByVal idUsuari As String) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE idUsuari=@idUsuari"
            command.Connection = con
            command.Transaction = trans

            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.Value = idUsuari
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)

            command.Prepare()

            deleteClient = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception

            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deleteClient = False
        End Try
    End Function

    Protected Overrides Function getNomTaula() As String
        getNomTaula = "Client"
    End Function


End Class