﻿Imports System.Data.Common
Imports LogManager

' ---------------------------------------------------------------------------------------------------------
' Implementem les funcions d'accés a dades a la taula Empleat
'----------------------------------------------------------------------------------------------------------

Public Class TaulaEmpleat
    Inherits Taula



    Public Function addEmpleat(ByVal idUsuari As String) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "INSERT INTO " & Me.getNomTaula & " (idUsuari) VALUES (@idUsuari)"
            command.Connection = con
            command.Transaction = trans

            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.Value = idUsuari
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)

            command.Prepare()

            addEmpleat = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception

            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            addEmpleat = False
        End Try
    End Function


    Public Function deleteEmpleat(ByVal idUsuari As Integer) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE idUsuari=@idUsuari"
            command.Connection = con
            command.Transaction = trans

            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)

            command.Prepare()

            deleteEmpleat = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deleteEmpleat = False
        End Try
    End Function

    Protected Overrides Function getNomTaula() As String
        getNomTaula = "Empleat"
    End Function


End Class