﻿Imports System.Data.Common
Imports LogManager

' ---------------------------------------------------------------------------------------------------------
' Implementem les funcions d'accés a dades a la taula PeticioServei
'----------------------------------------------------------------------------------------------------------
Public Class TaulaPeticioServei
    Inherits Taula

    Public Function getTotesPeticionsPerDataHora() As DataTable
        Try
            Dim dt As New DataTable(Me.getNomTaula())
            Dim con As DbConnection = Me.getDbConnection()
            ' con.Open()
            ' Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM " & Me.getNomTaula & " ORDER BY Data, Hora"
            command.Connection = con
            getTotesPeticionsPerDataHora = New DataTable(Me.getNomTaula())
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(getTotesPeticionsPerDataHora)
            adapter.Dispose()
            command.Dispose()
            ' trans.Commit()
            ' con.Close()
            con.Dispose()
        Catch ex As Exception
            getTotesPeticionsPerDataHora = Nothing
        End Try
    End Function

    Public Function addPeticio(ByVal Servei As Integer, ByVal Client As String, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "INSERT INTO " & Me.getNomTaula & " (Servei, Client, Data, Hora) VALUES (@Servei, @Client, @Data, @Hora)"
            command.Connection = con
            command.Transaction = trans

            Dim _Servei As DbParameter = Me.getDbParameter()
            _Servei.ParameterName = "Servei"
            _Servei.Value = Servei
            _Servei.DbType = DbType.Int32
            command.Parameters.Add(_Servei)

            Dim _Client As DbParameter = Me.getDbParameter()
            _Client.ParameterName = "Client"
            _Client.Value = Client
            _Client.DbType = DbType.String
            _Client.Size = 10
            command.Parameters.Add(_Client)

            Dim _Data As DbParameter = Me.getDbParameter()
            _Data.ParameterName = "Data"
            _Data.Value = Date.Parse(Data)
            _Data.DbType = DbType.Date
            command.Parameters.Add(_Data)

            Dim _Hora As DbParameter = Me.getDbParameter()
            _Hora.ParameterName = "Hora"
            _Hora.Value = Convert.ToDateTime(Convert.ToString(Hora))
            _Hora.DbType = DbType.Time
            command.Parameters.Add(_Hora)

            command.Prepare()

            addPeticio = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            'MsgBox("Excepció: " & ex.Message)
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            addPeticio = False
        End Try
    End Function


    Public Function deletePeticio(ByVal Servei As Integer, ByVal Client As String, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE Servei=@Servei AND Client=@Client AND CONVERT(CHAR(10),Data,3)=@Data AND CONVERT(CHAR(5),Hora)=@Hora"
            command.Connection = con
            command.Transaction = trans

            Dim _Servei As DbParameter = Me.getDbParameter()
            _Servei.ParameterName = "Servei"
            _Servei.Value = Trim(Servei)
            _Servei.DbType = DbType.Int32
            command.Parameters.Add(_Servei)

            Dim _Client As DbParameter = Me.getDbParameter()
            _Client.ParameterName = "Client"
            _Client.Value = Trim(Client)
            _Client.DbType = DbType.String
            _Client.Size = 10
            command.Parameters.Add(_Client)

            Dim _Data As DbParameter = Me.getDbParameter()
            _Data.ParameterName = "Data"
            '_Data.Value = Data.Day.ToString & "/" & Data.Month.ToString & "/" & Data.Year.ToString
            _Data.Value = Format(Data, "dd/MM/yy")
            _Data.DbType = DbType.String
            _Data.Size = 10
            command.Parameters.Add(_Data)

            Dim _Hora As DbParameter = Me.getDbParameter()
            _Hora.ParameterName = "Hora"
            _Hora.Value = Mid(Convert.ToString(Hora), 1, 5)
            _Hora.DbType = DbType.String
            _Hora.Size = 5
            command.Parameters.Add(_Hora)

            command.Prepare()


            deletePeticio = (command.ExecuteNonQuery() > 0)

            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()


        Catch ex As Exception

            'MsgBox("Excepció: " & ex.Message)
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deletePeticio = False
        End Try
    End Function

    Public Function deletePeticionsClient(ByVal Client As String) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE Client=@Client"
            command.Connection = con
            command.Transaction = trans


            Dim _Client As DbParameter = Me.getDbParameter()
            _Client.ParameterName = "Client"
            _Client.Value = Trim(Client)
            _Client.DbType = DbType.String
            _Client.Size = 10
            command.Parameters.Add(_Client)


            command.Prepare()


            deletePeticionsClient = (command.ExecuteNonQuery() > 0)

            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()

        Catch ex As Exception

            'MsgBox("Excepció: " & ex.Message)
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deletePeticionsClient = False
        End Try
    End Function
    Public Function deletePeticionsServei(ByVal Servei As Integer) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE Servei=@Servei"
            command.Connection = con
            command.Transaction = trans

            Dim _Servei As DbParameter = Me.getDbParameter()
            _Servei.ParameterName = "Servei"
            _Servei.Value = Trim(Servei)
            _Servei.DbType = DbType.Int32
            command.Parameters.Add(_Servei)

           
            command.Prepare()


            deletePeticionsServei = (command.ExecuteNonQuery() > 0)

            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()




        Catch ex As Exception

            'MsgBox("Excepció: " & ex.Message)
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deletePeticionsServei = False
        End Try
    End Function

    Protected Overrides Function getNomTaula() As String
        getNomTaula = "PeticioServei"
    End Function


End Class