﻿Imports System.Data.Common
Imports LogManager
' ---------------------------------------------------------------------------------------------------------
' Implementem les funcions d'accés a dades a la taula Recurs
'----------------------------------------------------------------------------------------------------------

Public Class TaulaRecurs
    Inherits Taula

    Public Function getTotsRecursosOrdenatsPerDescripcio() As DataTable
        Try
            Dim dt As New DataTable(Me.getNomTaula())
            Dim con As DbConnection = Me.getDbConnection()
            ' con.Open()
            ' Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM " & Me.getNomTaula & " ORDER BY Descripcio"
            command.Connection = con
            getTotsRecursosOrdenatsPerDescripcio = New DataTable(Me.getNomTaula())
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(getTotsRecursosOrdenatsPerDescripcio)
            adapter.Dispose()
            command.Dispose()
            ' trans.Commit()
            ' con.Close()
            con.Dispose()
        Catch ex As Exception
            getTotsRecursosOrdenatsPerDescripcio = Nothing
        End Try
    End Function

    Public Function addRecurs(ByVal Descripcio As String, ByVal NumPlaces As Integer) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "INSERT INTO " & Me.getNomTaula & " (Descripcio, NumPlaces) VALUES (@Descripcio, @NumPlaces)"
            command.Connection = con
            command.Transaction = trans

            Dim _descripcio As DbParameter = Me.getDbParameter()
            _descripcio.ParameterName = "Descripcio"
            _descripcio.Value = Descripcio
            _descripcio.DbType = DbType.String
            _descripcio.Size = 150
            command.Parameters.Add(_descripcio)

            Dim _numPlaces As DbParameter = Me.getDbParameter()
            _numPlaces.ParameterName = "NumPlaces"
            _numPlaces.Value = NumPlaces
            _numPlaces.DbType = DbType.Int32
            command.Parameters.Add(_numPlaces)

            command.Prepare()

            addRecurs = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            addRecurs = False
        End Try
    End Function


    Public Function deleteRecurs(ByVal idRecurs As Integer) As Boolean
        Try


            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE idRecurs=@idRecurs"
            command.Connection = con
            command.Transaction = trans

            Dim _idRecurs As DbParameter = Me.getDbParameter()
            _idRecurs.ParameterName = "idRecurs"
            _idRecurs.Value = idRecurs
            _idRecurs.DbType = DbType.Int32
            command.Parameters.Add(_idRecurs)

            command.Prepare()

            deleteRecurs = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()

        Catch ex As Exception

            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deleteRecurs = False
        End Try
    End Function

    Public Function updateRecurs(ByVal idRecurs As Integer, ByVal Descripcio As String, ByVal NumPlaces As Integer) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "UPDATE " & Me.getNomTaula & " SET Descripcio=@Descripcio, NumPlaces=@NumPlaces WHERE idRecurs=@idRecurs"
            command.Connection = con
            command.Transaction = trans

            Dim _descripcio As DbParameter = Me.getDbParameter()
            _descripcio.ParameterName = "Descripcio"
            _descripcio.Value = Descripcio
            _descripcio.DbType = DbType.String
            _descripcio.Size = 150
            command.Parameters.Add(_descripcio)

            Dim _numPlaces As DbParameter = Me.getDbParameter()
            _numPlaces.ParameterName = "NumPlaces"
            _numPlaces.Value = NumPlaces
            _numPlaces.DbType = DbType.Int32
            command.Parameters.Add(_numPlaces)

            Dim _idRecurs As DbParameter = Me.getDbParameter()
            _idRecurs.ParameterName = "idRecurs"
            _idRecurs.Value = idRecurs
            _idRecurs.DbType = DbType.Int32
            command.Parameters.Add(_idRecurs)

            command.Prepare()

            updateRecurs = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            updateRecurs = False
        End Try
    End Function

    Public Function getRecurs(ByVal idRecurs As Integer) As DataTable
        Try
            Dim dt As New DataTable(Me.getNomTaula())
            Dim con As DbConnection = Me.getDbConnection()
            ' con.Open()
            ' Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM " & Me.getNomTaula & " WHERE idRecurs=@idRecurs"
            command.Connection = con


            Dim _idRecurs As DbParameter = Me.getDbParameter()
            _idRecurs.ParameterName = "idRecurs"
            _idRecurs.Value = idRecurs
            _idRecurs.DbType = DbType.Int32
            command.Parameters.Add(_idRecurs)

            getRecurs = New DataTable(Me.getNomTaula())


            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(getRecurs)
            adapter.Dispose()
            command.Dispose()
            ' trans.Commit()
            ' con.Close()
            con.Dispose()
        Catch ex As Exception
            getRecurs = Nothing
        End Try
    End Function
    Protected Overrides Function getNomTaula() As String
        getNomTaula = "Recurs"
    End Function


End Class