﻿Imports System.Data.Common
Imports LogManager
' ---------------------------------------------------------------------------------------------------------
' Implementem les funcions d'accés a dades a la taula ReservaActivitats
'----------------------------------------------------------------------------------------------------------

Public Class TaulaReservaActivitat
    Inherits Taula

    Public Function getTotesReservesActivitats() As DataTable
        Try
            Dim dt As New DataTable(Me.getNomTaula())
            Dim con As DbConnection = Me.getDbConnection()
            ' con.Open()
            ' Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM " & Me.getNomTaula & " ORDER BY Activitat"
            command.Connection = con
            getTotesReservesActivitats = New DataTable(Me.getNomTaula())
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(getTotesReservesActivitats)
            adapter.Dispose()
            command.Dispose()
            ' trans.Commit()
            ' con.Close()
            con.Dispose()
        Catch ex As Exception
            getTotesReservesActivitats = Nothing
        End Try
    End Function

    Public Function addReservaActivitat(ByVal Activitat As Integer, ByVal Client As String, ByVal Places As Integer) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "INSERT INTO " & Me.getNomTaula & " (Activitat, Client,Places) VALUES (@Activitat, @Client, @Places)"
            command.Connection = con
            command.Transaction = trans

            Dim _Activitat As DbParameter = Me.getDbParameter()
            _Activitat.ParameterName = "Activitat"
            _Activitat.Value = Activitat
            _Activitat.DbType = DbType.Int32
            command.Parameters.Add(_Activitat)

            Dim _Places As DbParameter = Me.getDbParameter()
            _Places.ParameterName = "Places"
            _Places.Value = Places
            _Places.DbType = DbType.Int32
            command.Parameters.Add(_Places)

            Dim _Client As DbParameter = Me.getDbParameter()
            _Client.ParameterName = "Client"
            _Client.Value = Client
            _Client.DbType = DbType.String
            _Client.Size = 10
            command.Parameters.Add(_Client)

            command.Prepare()

            addReservaActivitat = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            addReservaActivitat = False
        End Try
    End Function


    Public Function deleteReservaActivitat(ByVal Activitat As Integer, ByVal Client As String) As Boolean
        Dim trans As DbTransaction
        Dim con As DbConnection
        Try
            con = Me.getDbConnection()
            con.Open()
            ' Dim trans As DbTransaction = con.BeginTransaction
            trans = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()


            Dim command0 As DbCommand = Me.getDbCommand()
            command0.CommandText = "UPDATE Activitat SET NumPlaces=NumPlaces+(SELECT Places FROM ReservaActivitat WHERE idActivitat=@Activitat AND Client=@Client) WHERE idActivitat=@Activitat"
            command0.Connection = con
            command0.Transaction = trans

            Dim _Activitat0 As DbParameter = Me.getDbParameter()
            _Activitat0.ParameterName = "Activitat"
            _Activitat0.Value = Activitat
            _Activitat0.DbType = DbType.Int32
            command0.Parameters.Add(_Activitat0)

            Dim _Client0 As DbParameter = Me.getDbParameter()
            _Client0.ParameterName = "Client"
            _Client0.Value = Client
            _Client0.DbType = DbType.String
            _Client0.Size = 10
            command0.Parameters.Add(_Client0)


            command0.Prepare()
            command0.ExecuteNonQuery()
            command0.Dispose()


            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE Activitat=@Activitat AND Client=@Client"
            command.Connection = con
            command.Transaction = trans

            Dim _Activitat As DbParameter = Me.getDbParameter()
            _Activitat.ParameterName = "Activitat"
            _Activitat.Value = Activitat
            _Activitat.DbType = DbType.Int32
            command.Parameters.Add(_Activitat)

            Dim _Client As DbParameter = Me.getDbParameter()
            _Client.ParameterName = "Client"
            _Client.Value = Client
            _Client.DbType = DbType.String
            _Client.Size = 10
            command.Parameters.Add(_Client)

            command.Prepare()

            deleteReservaActivitat = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception

            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deleteReservaActivitat = False
            If Not trans Is Nothing Then
                Try
                    trans.Rollback()

                Catch ex2 As Exception
                End Try
            End If
        End Try
    End Function

    Public Function deleteResActRelacionades(ByVal Activitat As Integer) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE Activitat=@Activitat"
            command.Connection = con
            command.Transaction = trans

            Dim _Activitat As DbParameter = Me.getDbParameter()
            _Activitat.ParameterName = "Activitat"
            _Activitat.Value = Activitat
            _Activitat.DbType = DbType.Int32
            command.Parameters.Add(_Activitat)

            command.Prepare()

            deleteResActRelacionades = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deleteResActRelacionades = False
        End Try
    End Function

    Public Function deleteReservesActClient(ByVal Client As String) As Boolean
        Try

            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE Client=@Client"
            command.Connection = con
            command.Transaction = trans

           

            Dim command0 As DbCommand = Me.getDbCommand()
            command0.CommandText = "SELECT Activitat, Places FROM ReservaActivitat WHERE Client=@Client"
            command0.Connection = con
            command0.Transaction = trans

            Dim _Client0 As DbParameter = Me.getDbParameter()
            _Client0.ParameterName = "Client"
            _Client0.Value = Client
            _Client0.DbType = DbType.String
            _Client0.Size = 10
            command0.Parameters.Add(_Client0)


            Dim dt As DataTable = New DataTable(Me.getNomTaula())
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command0
            adapter.Fill(dt)
            adapter.Dispose()
            command0.Dispose()
            'con.Dispose()
            'Dim dt As DataTable =

            'Dim reader As DbDataReader = command0.ExecuteReader()
            'command0.Dispose()
            'Dim command1 As DbCommand = Me.getDbCommand()

            'con.Open()
            For Each row In dt.Rows
                Dim idActivitat As Integer = CInt(row("Activitat"))
                Dim Places As Integer = CInt(row("Places"))

                Dim command1 As DbCommand = Me.getDbCommand()
                command1.CommandText = "UPDATE Activitat SET NumPlaces=NumPlaces+@Places WHERE idActivitat=@idActivitat"
                command1.Connection = con
                command1.Transaction = trans

                Dim _Activitat As DbParameter = Me.getDbParameter()
                _Activitat.ParameterName = "idActivitat"
                _Activitat.Value = idActivitat
                _Activitat.DbType = DbType.Int32
                command1.Parameters.Add(_Activitat)

                Dim _Places As DbParameter = Me.getDbParameter()
                _Places.ParameterName = "Places"
                _Places.Value = Places
                _Places.DbType = DbType.Int32
                command1.Parameters.Add(_Places)

                command1.Prepare()
                command1.ExecuteNonQuery()
                command1.Dispose()


            Next

            command0.Dispose()


            Dim _Client As DbParameter = Me.getDbParameter()
            _Client.ParameterName = "Client"
            _Client.Value = Client
            _Client.DbType = DbType.String
            _Client.Size = 10
            command.Parameters.Add(_Client)

            command.Prepare()

            deleteReservesActClient = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deleteReservesActClient = False
        End Try
    End Function

    Protected Overrides Function getNomTaula() As String
        getNomTaula = "ReservaActivitat"
    End Function


End Class