﻿Imports System.Data.Common
Imports LogManager

' ---------------------------------------------------------------------------------------------------------
' Implementem les funcions d'accés a dades a la taula ReservaRecurs
'----------------------------------------------------------------------------------------------------------

Public Class TaulaReservaRecurs
    Inherits Taula

    Public Function getTotesReservesRecursPerDataHora() As DataTable
        Try
            Dim dt As New DataTable(Me.getNomTaula())
            Dim con As DbConnection = Me.getDbConnection()
            ' con.Open()
            ' Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM " & Me.getNomTaula & " ORDER BY Data, Hora"
            command.Connection = con
            getTotesReservesRecursPerDataHora = New DataTable(Me.getNomTaula())
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(getTotesReservesRecursPerDataHora)
            adapter.Dispose()
            command.Dispose()
            ' trans.Commit()
            ' con.Close()
            con.Dispose()
        Catch ex As Exception
            getTotesReservesRecursPerDataHora = Nothing
        End Try
    End Function

    Public Function recursDisponible(ByVal Recurs As Integer, ByVal Data As Date, ByVal Hora As TimeSpan) As DataTable
        Try
            Dim dt As New DataTable(Me.getNomTaula())
            Dim con As DbConnection = Me.getDbConnection()
            ' con.Open()
            ' Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT COUNT(Recurs) quants FROM " & Me.getNomTaula & " WHERE Recurs=@Recurs AND CONVERT(CHAR(10),Data,3)=@Data AND CONVERT(CHAR(5),Hora)=@Hora"
            command.Connection = con

            Dim _Recurs As DbParameter = Me.getDbParameter()
            _Recurs.ParameterName = "Recurs"
            _Recurs.Value = Recurs
            _Recurs.DbType = DbType.Int32
            command.Parameters.Add(_Recurs)

            Dim _Data As DbParameter = Me.getDbParameter()
            _Data.ParameterName = "Data"
            '_Data.Value = Data.Day.ToString & "/" & Data.Month.ToString & "/" & Data.Year.ToString
            _Data.Value = Format(Data, "dd/MM/yy")
            _Data.DbType = DbType.String
            _Data.Size = 10
            command.Parameters.Add(_Data)

            Dim _Hora As DbParameter = Me.getDbParameter()
            _Hora.ParameterName = "Hora"
            _Hora.Value = Mid(Convert.ToString(Hora), 1, 5)
            _Hora.DbType = DbType.String
            _Hora.Size = 5
            command.Parameters.Add(_Hora)



            recursDisponible = New DataTable(Me.getNomTaula())
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(recursDisponible)
            adapter.Dispose()
            command.Dispose()
            ' trans.Commit()
            ' con.Close()
            con.Dispose()
        Catch ex As Exception
            recursDisponible = Nothing
        End Try
    End Function

    Public Function addReservaRecurs(ByVal Recurs As Integer, ByVal Client As String, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "INSERT INTO " & Me.getNomTaula & " (Recurs, Client, Data, Hora) VALUES (@Recurs, @Client, @Data, @Hora)"
            command.Connection = con
            command.Transaction = trans

            Dim _Recurs As DbParameter = Me.getDbParameter()
            _Recurs.ParameterName = "Recurs"
            _Recurs.Value = Recurs
            _Recurs.DbType = DbType.Int32
            command.Parameters.Add(_Recurs)

            Dim _Client As DbParameter = Me.getDbParameter()
            _Client.ParameterName = "Client"
            _Client.Value = Client
            _Client.DbType = DbType.String
            _Client.Size = 10
            command.Parameters.Add(_Client)

            Dim _Data As DbParameter = Me.getDbParameter()
            _Data.ParameterName = "Data"
            _Data.Value = Data
            _Data.DbType = DbType.Date
            command.Parameters.Add(_Data)

            Dim _Hora As DbParameter = Me.getDbParameter()
            _Hora.ParameterName = "Hora"
            _Hora.Value = Convert.ToDateTime(Convert.ToString(Hora))
            _Hora.DbType = DbType.Time
            command.Parameters.Add(_Hora)



            command.Prepare()

            addReservaRecurs = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception

            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            addReservaRecurs = False
        End Try
    End Function


    Public Function deleteReservaRecurs(ByVal Recurs As Integer, ByVal Client As String, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE Recurs=@Recurs AND Client=@Client AND CONVERT(CHAR(10),Data,3)=@Data AND CONVERT(CHAR(5),Hora)=@Hora"
            command.Connection = con
            command.Transaction = trans

            Dim _Recurs As DbParameter = Me.getDbParameter()
            _Recurs.ParameterName = "Recurs"
            _Recurs.Value = Recurs
            _Recurs.DbType = DbType.Int32
            command.Parameters.Add(_Recurs)

            Dim _Client As DbParameter = Me.getDbParameter()
            _Client.ParameterName = "Client"
            _Client.Value = Client
            _Client.DbType = DbType.String
            _Client.Size = 10
            command.Parameters.Add(_Client)

            Dim _Data As DbParameter = Me.getDbParameter()
            _Data.ParameterName = "Data"
            '_Data.Value = Data.Day.ToString & "/" & Data.Month.ToString & "/" & Data.Year.ToString
            _Data.Value = Format(Data, "dd/MM/yy")
            _Data.DbType = DbType.String
            _Data.Size = 10
            command.Parameters.Add(_Data)

            Dim _Hora As DbParameter = Me.getDbParameter()
            _Hora.ParameterName = "Hora"
            _Hora.Value = Mid(Convert.ToString(Hora), 1, 5)
            _Hora.DbType = DbType.String
            _Hora.Size = 5
            command.Parameters.Add(_Hora)

            command.Prepare()



            deleteReservaRecurs = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception

            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deleteReservaRecurs = False
        End Try
    End Function
    Public Function deleteResRecursosClient(ByVal Client As String) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE Client=@Client"
            command.Connection = con
            command.Transaction = trans

            Dim _Client As DbParameter = Me.getDbParameter()
            _Client.ParameterName = "Client"
            _Client.Value = Client
            _Client.DbType = DbType.String
            _Client.Size = 10
            command.Parameters.Add(_Client)

            command.Prepare()

            deleteResRecursosClient = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            'MsgBox("Excepció: " & ex.Message)
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deleteResRecursosClient = False
        End Try

    End Function
    Public Function deleteReservesRecurs(ByVal Recurs As Integer) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE Recurs=@Recurs"
            command.Connection = con
            command.Transaction = trans

            Dim _Recurs As DbParameter = Me.getDbParameter()
            _Recurs.ParameterName = "Recurs"
            _Recurs.Value = Recurs
            _Recurs.DbType = DbType.Int32
            command.Parameters.Add(_Recurs)

            command.Prepare()

            deleteReservesRecurs = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            'MsgBox("Excepció: " & ex.Message)
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deleteReservesRecurs = False
        End Try
    End Function

    Protected Overrides Function getNomTaula() As String
        getNomTaula = "ReservaRecurs"
    End Function


End Class