﻿Imports System.Data.Common
Imports LogManager
' ---------------------------------------------------------------------------------------------------------
' Implementem les funcions d'accés a dades a la taula Serveis
'----------------------------------------------------------------------------------------------------------

Public Class TaulaServei
    Inherits Taula

    Public Function getTotsServeisOrdenatsPerDescripcio() As DataTable
        Try
            Dim dt As New DataTable(Me.getNomTaula())
            Dim con As DbConnection = Me.getDbConnection()
            ' con.Open()
            ' Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM " & Me.getNomTaula & " ORDER BY Descripcio"
            command.Connection = con
            getTotsServeisOrdenatsPerDescripcio = New DataTable(Me.getNomTaula())
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(getTotsServeisOrdenatsPerDescripcio)
            adapter.Dispose()
            command.Dispose()
            ' trans.Commit()
            ' con.Close()
            con.Dispose()
        Catch ex As Exception
            getTotsServeisOrdenatsPerDescripcio = Nothing
        End Try
    End Function

    Public Function addServei(ByVal Descripcio As String) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "INSERT INTO " & Me.getNomTaula & " (Descripcio) VALUES (@Descripcio)"
            command.Connection = con
            command.Transaction = trans

            Dim _descripcio As DbParameter = Me.getDbParameter()
            _descripcio.ParameterName = "Descripcio"
            _descripcio.Value = Descripcio
            _descripcio.DbType = DbType.String
            _descripcio.Size = 150
            command.Parameters.Add(_descripcio)


            command.Prepare()

            addServei = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            addServei = False
        End Try
    End Function


    Public Function deleteServei(ByVal idServei As Integer) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE idServei=@idServei"
            command.Connection = con
            command.Transaction = trans

            Dim _idActivitat As DbParameter = Me.getDbParameter()
            _idActivitat.ParameterName = "idServei"
            _idActivitat.Value = idServei
            _idActivitat.DbType = DbType.Int32
            command.Parameters.Add(_idActivitat)

            command.Prepare()

            deleteServei = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deleteServei = False
        End Try
    End Function

    Public Function updateServei(ByVal idServei As Integer, ByVal Descripcio As String) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "UPDATE " & Me.getNomTaula & " SET Descripcio=@Descripcio WHERE idServei=@idServei"
            command.Connection = con
            command.Transaction = trans

            Dim _descripcio As DbParameter = Me.getDbParameter()
            _descripcio.ParameterName = "Descripcio"
            _descripcio.Value = Descripcio
            _descripcio.DbType = DbType.String
            _descripcio.Size = 150
            command.Parameters.Add(_descripcio)


            Dim _idServei As DbParameter = Me.getDbParameter()
            _idServei.ParameterName = "idServei"
            _idServei.Value = idServei
            _idServei.DbType = DbType.Int32
            command.Parameters.Add(_idServei)

            command.Prepare()

            updateServei = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            updateServei = False
        End Try
    End Function


    Protected Overrides Function getNomTaula() As String
        getNomTaula = "Servei"
    End Function


End Class