﻿Imports System.Data.Common
Imports LogManager

' ---------------------------------------------------------------------------------------------------------
' Implementem les funcions d'accés a dades a la taula Uuaris
'----------------------------------------------------------------------------------------------------------
Public Class TaulaUsuaris
    Inherits Taula

    Public Function getTotsUsuarisOrdenatsPerCognom() As DataTable
        Try
            Dim dt As New DataTable(Me.getNomTaula())
            Dim con As DbConnection = Me.getDbConnection()
            ' con.Open()
            ' Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "SELECT * FROM " & Me.getNomTaula & " ORDER BY Cognom1, Cognom2, Nom"
            command.Connection = con
            getTotsUsuarisOrdenatsPerCognom = New DataTable(Me.getNomTaula())
            Dim adapter As DbDataAdapter = Me.getDbDataAdapter()
            adapter.SelectCommand = command
            adapter.Fill(getTotsUsuarisOrdenatsPerCognom)
            adapter.Dispose()
            command.Dispose()
            ' trans.Commit()
            ' con.Close()
            con.Dispose()
        Catch ex As Exception
            getTotsUsuarisOrdenatsPerCognom = Nothing
        End Try
    End Function

    Public Function addUsuari(ByVal idUsuari As String, ByVal Nom As String, ByVal Cognom1 As String, ByVal Cognom2 As String, ByVal Password As String) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "INSERT INTO " & Me.getNomTaula & " (idUsuari, Nom, Cognom1, Cognom2) VALUES (@idUsuari, @Nom, @Cognom1, @Cognom2 )"
            command.Connection = con
            command.Transaction = trans

            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.Value = idUsuari
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)

            Dim _Password As DbParameter = Me.getDbParameter()
            _Password.ParameterName = "Password"
            _Password.Value = Password
            _Password.DbType = DbType.String
            _Password.Size = 8
            command.Parameters.Add(_Password)

            Dim _Nom As DbParameter = Me.getDbParameter()
            _Nom.ParameterName = "Nom"
            _Nom.Value = Nom
            _Nom.DbType = DbType.String
            _Nom.Size = 45
            command.Parameters.Add(_Nom)

            Dim _Cognom1 As DbParameter = Me.getDbParameter()
            _Cognom1.ParameterName = "Cognom1"
            _Cognom1.Value = Cognom1
            _Cognom1.DbType = DbType.String
            _Cognom1.Size = 45
            command.Parameters.Add(_Cognom1)

            Dim _Cognom2 As DbParameter = Me.getDbParameter()
            _Cognom2.ParameterName = "Cognom2"
            _Cognom2.Value = Cognom2
            _Cognom2.DbType = DbType.String
            _Cognom2.Size = 45
            command.Parameters.Add(_Cognom2)


            command.Prepare()

            addUsuari = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            addUsuari = False
        End Try
    End Function


    Public Function deleteUsuari(ByVal idUsuari As Integer) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "DELETE FROM " & Me.getNomTaula & " WHERE idUsuari=@idUsuari"
            command.Connection = con
            command.Transaction = trans

            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.Value = idUsuari
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)

            command.Prepare()

            deleteUsuari = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            deleteUsuari = False
        End Try
    End Function

    Public Function updateUsuari(ByVal idUsuari As String, ByVal Nom As String, ByVal Cognom1 As String, ByVal Cognom2 As String, ByVal Password As String) As Boolean
        Try
            Dim con As DbConnection = Me.getDbConnection()
            con.Open()
            Dim trans As DbTransaction = con.BeginTransaction
            Dim command As DbCommand = Me.getDbCommand()
            command.CommandText = "UPDATE " & Me.getNomTaula & " SET Nom=@Nom, Cognom1=@Cognom1, Cognom2=@Cognom2, Password=@Password WHERE idUsuari=@idUsuari"
            command.Connection = con
            command.Transaction = trans

            Dim _idUsuari As DbParameter = Me.getDbParameter()
            _idUsuari.ParameterName = "idUsuari"
            _idUsuari.Value = idUsuari
            _idUsuari.DbType = DbType.String
            _idUsuari.Size = 10
            command.Parameters.Add(_idUsuari)



            Dim _Nom As DbParameter = Me.getDbParameter()
            _Nom.ParameterName = "Nom"
            _Nom.Value = Nom
            _Nom.DbType = DbType.String
            _Nom.Size = 45
            command.Parameters.Add(_Nom)

            Dim _Password As DbParameter = Me.getDbParameter()
            _Password.ParameterName = "Password"
            _Password.Value = Password
            _Password.DbType = DbType.String
            _Password.Size = 8
            command.Parameters.Add(_Password)

            Dim _Cognom1 As DbParameter = Me.getDbParameter()
            _Cognom1.ParameterName = "Cognom1"
            _Cognom1.Value = Cognom1
            _Cognom1.DbType = DbType.String
            _Cognom1.Size = 45
            command.Parameters.Add(_Cognom1)

            Dim _Cognom2 As DbParameter = Me.getDbParameter()
            _Cognom2.ParameterName = "Cognom2"
            _Cognom2.Value = Cognom2
            _Cognom2.DbType = DbType.String
            _Cognom2.Size = 45
            command.Parameters.Add(_Cognom2)

            command.Prepare()

            updateUsuari = (command.ExecuteNonQuery() > 0)
            trans.Commit()
            command.Dispose()
            con.Close()
            con.Dispose()
        Catch ex As Exception
            LogManager.LogManager.escriuLog("Excepció: " & ex.Message & Environment.NewLine() & ex.StackTrace)
            updateUsuari = False
        End Try
    End Function


    Protected Overrides Function getNomTaula() As String
        getNomTaula = "Usuaris"
    End Function


End Class