﻿' NOTA: si cambia aquí el nombre de clase "Service1", también debe actualizar la referencia a "Service1" tanto en Web.config como en el archivo .svc asociado.

' ---------------------------------------------------------------------------------------------------------
' Aquí implementem les funcions que seràn accessibles des de l'aplicació client, que criden a funcions
' definides al mòdul DataBase (que és la capa que connecta amb la base de dades) 
'----------------------------------------------------------------------------------------------------------

Public Class XPAServer
    Implements IXPAServer

    'mestre Activitats
    Function getActivitats() As DataTable Implements IXPAServer.getActivitats
        Try
            Dim activitats As DataBase.TaulaActivitat = New DataBase.TaulaActivitat()
            getActivitats = activitats.getTotesActivitatsOrdenadesPerDescripcio()
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            getActivitats = Nothing
        End Try
    End Function

    Function addActivitat(ByVal Descripcio As String, ByVal NumPlaces As Integer, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean Implements IXPAServer.addActivitat
        Try
            Dim activitats As DataBase.TaulaActivitat = New DataBase.TaulaActivitat()
            addActivitat = activitats.addActivitat(Descripcio, NumPlaces, Data, Hora)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            addActivitat = Nothing
        End Try
    End Function

    Function deleteActivitat(ByVal idActividad As Integer) As Boolean Implements IXPAServer.deleteActivitat
        Try
            Dim activitats As DataBase.TaulaActivitat = New DataBase.TaulaActivitat()
            deleteActivitat = activitats.deleteActivitat(idActividad)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deleteActivitat = Nothing
        End Try
    End Function

    Function updateActivitat(ByVal idActividad As Integer, ByVal Descripcio As String, ByVal NumPlaces As Integer, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean Implements IXPAServer.updateActivitat
        Try
            Dim activitats As DataBase.TaulaActivitat = New DataBase.TaulaActivitat()
            updateActivitat = activitats.updateActivitat(idActividad, Descripcio, NumPlaces, Data, Hora)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            updateActivitat = Nothing
        End Try
    End Function

    Function getTotsAgenda() As DataTable Implements IXPAServer.getTotsAgenda
        Try
            Dim consultes As New DataBase.Consultes
            getTotsAgenda = consultes.getTotsAgenda()
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            getTotsAgenda = Nothing
        End Try
    End Function

    Function addReservaRecurs(ByVal Recurs As Integer, ByVal Client As String, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean Implements IXPAServer.addReservaRecurs
        Try
            Dim _reserva As New DataBase.TaulaReservaRecurs
            addReservaRecurs = _reserva.addReservaRecurs(Recurs, Client, Data, Hora)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            addReservaRecurs = False
        End Try
    End Function

    Function getTotsRecursosOrdenatsPerDescripcio() As DataTable Implements IXPAServer.getTotsRecursosOrdenatsPerDescripcio
        Try
            Dim _recursos As New DataBase.TaulaRecurs
            getTotsRecursosOrdenatsPerDescripcio = _recursos.getTotsRecursosOrdenatsPerDescripcio
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            getTotsRecursosOrdenatsPerDescripcio = Nothing
        End Try
    End Function
    Function getTotsServeisOrdenatsPerDescripcio() As DataTable Implements IXPAServer.getTotsServeisOrdenatsPerDescripcio
        Try
            Dim _Serveis As New DataBase.TaulaServei
            getTotsServeisOrdenatsPerDescripcio = _Serveis.getTotsServeisOrdenatsPerDescripcio
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            getTotsServeisOrdenatsPerDescripcio = Nothing
        End Try
    End Function

    Function cercaClients(ByVal nom As String, ByVal cognom1 As String, ByVal cognom2 As String, ByVal idclient As String) As DataTable Implements IXPAServer.cercaClients
        Try
            Dim _Clients As New DataBase.Consultes
            cercaClients = _Clients.cercaClients(nom, cognom1, cognom2, idclient)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            cercaClients = Nothing
        End Try
    End Function

    Function CercaUsuari(ByVal idUsuari As String) As DataTable Implements IXPAServer.CercaUsuari
        Try
            Dim _Usuari As New DataBase.Consultes
            CercaUsuari = _Usuari.CercaUsuari(idUsuari)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            CercaUsuari = Nothing
        End Try
    End Function
    Function getAgendaClient(ByVal idUsuari As String) As DataTable Implements IXPAServer.getAgendaClient
        Try
            Dim _Agenda As New DataBase.Consultes
            getAgendaClient = _Agenda.getAgendaClient(idUsuari)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            getAgendaClient = Nothing
        End Try
    End Function
    Function getActivitatsOrdenadesDisponibles() As DataTable Implements IXPAServer.getActivitatsOrdenadesDisponibles
        Try
            Dim _Activitats As New DataBase.TaulaActivitat
            getActivitatsOrdenadesDisponibles = _Activitats.getActivitatsOrdenadesDisponibles()
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            getActivitatsOrdenadesDisponibles = Nothing
        End Try
    End Function
    Function getActivitat(ByVal idActivitat) As DataTable Implements IXPAServer.getActivitat
        Try
            Dim _Activitat As New DataBase.TaulaActivitat
            getActivitat = _Activitat.getActivitat(idActivitat)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            getActivitat = Nothing
        End Try
    End Function
    Function addReservaActivitat(ByVal Activitat As Integer, ByVal Client As String, ByVal Places As Integer) As Boolean Implements IXPAServer.addReservaActivitat
        Try
            Dim _reserva As New DataBase.TaulaReservaActivitat
            addReservaActivitat = _reserva.addReservaActivitat(Activitat, Client, Places)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            addReservaActivitat = False
        End Try
    End Function
    Function updateActPlaces(ByVal idActividad As Integer, ByVal NumPlaces As Integer) As Boolean Implements IXPAServer.updateActPlaces
        Try
            Dim _Activitat As New DataBase.TaulaActivitat
            updateActPlaces = _Activitat.updateActPlaces(idActividad, NumPlaces)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            updateActPlaces = False
        End Try
    End Function
    Function addPeticio(ByVal Servei As Integer, ByVal Client As String, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean Implements IXPAServer.addPeticio
        Try
            Dim _Peticio As New DataBase.TaulaPeticioServei
            addPeticio = _Peticio.addPeticio(Servei, Client, Data, Hora)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            addPeticio = False
        End Try
    End Function
    Function deleteReservaActivitat(ByVal Activitat As Integer, ByVal Client As String) As Boolean Implements IXPAServer.deleteReservaActivitat
        Try
            Dim _Activitat As New DataBase.TaulaReservaActivitat
            deleteReservaActivitat = _Activitat.deleteReservaActivitat(Activitat, Client)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deleteReservaActivitat = False
        End Try
    End Function
    Function deleteReservaRecurs(ByVal Recurs As Integer, ByVal Client As String, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean Implements IXPAServer.deleteReservaRecurs
        Try
            Dim _Recurs As New DataBase.TaulaReservaRecurs
            deleteReservaRecurs = _Recurs.deleteReservaRecurs(Recurs, Client, Data, Hora)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deleteReservaRecurs = False
        End Try
    End Function
    Function deletePeticio(ByVal Servei As Integer, ByVal Client As String, ByVal Data As Date, ByVal Hora As TimeSpan) As Boolean Implements IXPAServer.deletePeticio
        Try
            Dim _Peticio As New DataBase.TaulaPeticioServei
            deletePeticio = _Peticio.deletePeticio(Servei, Client, Data, Hora)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deletePeticio = False
        End Try
    End Function
    Function EsEmpleat(ByVal idUsuari As String) As DataTable Implements IXPAServer.EsEmpleat
        Try
            Dim _Usuari As New DataBase.Consultes
            EsEmpleat = _Usuari.EsEmpleat(idUsuari)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            EsEmpleat = Nothing
        End Try
    End Function
    Function getTotsUsuarisOrdenatsPerCognom() As DataTable Implements IXPAServer.getTotsUsuarisOrdenatsPerCognom
        Try
            Dim _Usuaris As New DataBase.TaulaUsuaris
            getTotsUsuarisOrdenatsPerCognom = _Usuaris.getTotsUsuarisOrdenatsPerCognom()
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            getTotsUsuarisOrdenatsPerCognom = Nothing
        End Try
    End Function
    Function CercaClient(ByVal idUsuari As String) As DataTable Implements IXPAServer.CercaClient
        Try
            Dim _Usuari As New DataBase.Consultes
            CercaClient = _Usuari.CercaClient(idUsuari)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            CercaClient = Nothing
        End Try
    End Function
    Function CercaEmpl(ByVal idUsuari As String) As DataTable Implements IXPAServer.CercaEmpl
        Try
            Dim _Usuari As New DataBase.Consultes
            CercaEmpl = _Usuari.CercaEmpl(idUsuari)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            CercaEmpl = Nothing
        End Try
    End Function
    Function addClient(ByVal idUsuari As String, ByVal NumHabitacio As Integer, ByVal Data As Date) As Boolean Implements IXPAServer.addClient
        Try
            Dim _Client As New DataBase.TaulaClient
            addClient = _Client.addClient(idUsuari, NumHabitacio, Data)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            addClient = False
        End Try
    End Function

    Function addUsuari(ByVal idUsuari As String, ByVal Nom As String, ByVal Cognom1 As String, ByVal Cognom2 As String, ByVal Password As String) As Boolean Implements IXPAServer.addUsuari
        Try
            Dim _Usu As New DataBase.TaulaUsuaris
            addUsuari = _Usu.addUsuari(idUsuari, Nom, Cognom1, Cognom2, Password)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            addUsuari = False
        End Try
    End Function
    Function deleteClient(ByVal idUsuari As String) As Boolean Implements IXPAServer.deleteClient
        Try
            Dim _Client As New DataBase.TaulaClient
            deleteClient = _Client.deleteClient(idUsuari)
            'deleteUsuari(idUsuari)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deleteClient = False
        End Try

    End Function
    Function deleteUsuari(ByVal idUsuari As String) As Boolean Implements IXPAServer.deleteUsuari
        Try
            Dim _Usu As New DataBase.TaulaUsuaris
            deleteUsuari = _Usu.deleteUsuari(idUsuari)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deleteUsuari = False
        End Try
    End Function

    Function deleteEmpleat(ByVal idUsuari As String) As Boolean Implements IXPAServer.deleteEmpleat
        Try
            Dim _Empl As New DataBase.TaulaEmpleat
            deleteEmpleat = _Empl.deleteEmpleat(idUsuari)
            'deleteUsuari(idUsuari)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deleteEmpleat = False
        End Try
    End Function
    Function addEmpleat(ByVal idUsuari As String) As Boolean Implements IXPAServer.addEmpleat
        Try
            Dim _Empl As New DataBase.TaulaEmpleat
            addEmpleat = _Empl.addEmpleat(idUsuari)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            addEmpleat = False
        End Try
    End Function
    Function updateUsuari(ByVal idUsuari As String, ByVal Nom As String, ByVal Cognom1 As String, ByVal Cognom2 As String, ByVal Password As String) As Boolean Implements IXPAServer.updateUsuari
        Try
            Dim _Usu As New DataBase.TaulaUsuaris
            updateUsuari = _Usu.updateUsuari(idUsuari, Nom, Cognom1, Cognom2, Password)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            updateUsuari = False
        End Try
    End Function
    Function updateClient(ByVal idUsuari As String, ByVal NumHabitacio As Integer) As Boolean Implements IXPAServer.updateClient
        Try
            Dim _Usu As New DataBase.TaulaClient
            updateClient = _Usu.updateClient(idUsuari, NumHabitacio)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            updateClient = False
        End Try
    End Function
    Function addServei(ByVal Descripcio As String) As Boolean Implements IXPAServer.addServei
        Try
            Dim _Ser As New DataBase.TaulaServei
            addServei = _Ser.addServei(Descripcio)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            addServei = False
        End Try
    End Function
    Function deleteServei(ByVal idServei As Integer) As Boolean Implements IXPAServer.deleteServei
        Try
            Dim _Ser As New DataBase.TaulaServei
            deleteServei = _Ser.deleteServei(idServei)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deleteServei = False
        End Try
    End Function
    Function updateServei(ByVal idServei As Integer, ByVal Descripcio As String) As Boolean Implements IXPAServer.updateServei
        Try
            Dim _Ser As New DataBase.TaulaServei
            updateServei = _Ser.updateServei(idServei, Descripcio)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            updateServei = False
        End Try
    End Function
    Function addRecurs(ByVal Descripcio As String, ByVal NumPlaces As Integer) As Boolean Implements IXPAServer.addRecurs
        Try
            Dim _Rec As New DataBase.TaulaRecurs
            addRecurs = _Rec.addRecurs(Descripcio, NumPlaces)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            addRecurs = False
        End Try
    End Function
    Function deleteRecurs(ByVal idRecurs As Integer) As Boolean Implements IXPAServer.deleteRecurs
        Try
            Dim _Rec As New DataBase.TaulaRecurs
            deleteRecurs = _Rec.deleteRecurs(idRecurs)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deleteRecurs = False
        End Try
    End Function
    Function updateRecurs(ByVal idRecurs As Integer, ByVal Descripcio As String, ByVal NumPlaces As Integer) As Boolean Implements IXPAServer.updateRecurs
        Try
            Dim _Rec As New DataBase.TaulaRecurs
            updateRecurs = _Rec.updateRecurs(idRecurs, Descripcio, NumPlaces)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            updateRecurs = False
        End Try
    End Function
    Function getRecurs(ByVal idRecurs As Integer) As DataTable Implements IXPAServer.getRecurs
        Try
            Dim _Rec As New DataBase.TaulaRecurs
            getRecurs = _Rec.getRecurs(idRecurs)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            getRecurs = Nothing
        End Try
    End Function
    Function deleteResActRelacionades(ByVal Activitat As Integer) As Boolean Implements IXPAServer.deleteResActRelacionades
        Try
            Dim _Res As New DataBase.TaulaReservaActivitat
            deleteResActRelacionades = _Res.deleteResActRelacionades(Activitat)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deleteResActRelacionades = False
        End Try
    End Function
    Function deleteReservesActClient(ByVal Client As String) As Boolean Implements IXPAServer.deleteReservesActClient
        Try
            Dim _Res As New DataBase.TaulaReservaActivitat
            deleteReservesActClient = _Res.deleteReservesActClient(Client)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deleteReservesActClient = False
        End Try
    End Function
    Function deleteResRecursosClient(ByVal Client As String) As Boolean Implements IXPAServer.deleteResRecursosClient
        Try
            Dim _Res As New DataBase.TaulaReservaRecurs
            deleteResRecursosClient = _Res.deleteResRecursosClient(Client)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deleteResRecursosClient = False
        End Try
    End Function
    Function deleteReservesRecurs(ByVal Recurs As Integer) As Boolean Implements IXPAServer.deleteReservesRecurs
        Try
            Dim _Res As New DataBase.TaulaReservaRecurs
            deleteReservesRecurs = _Res.deleteReservesRecurs(Recurs)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deleteReservesRecurs = False
        End Try
    End Function
    Function deletePeticionsClient(ByVal Client As String) As Boolean Implements IXPAServer.deletePeticionsClient
        Try
            Dim _Res As New DataBase.TaulaPeticioServei
            deletePeticionsClient = _Res.deletePeticionsClient(Client)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deletePeticionsClient = False
        End Try
    End Function
    Function deletePeticionsServei(ByVal Servei As Integer) As Boolean Implements IXPAServer.deletePeticionsServei
        Try
            Dim _Res As New DataBase.TaulaPeticioServei
            deletePeticionsServei = _Res.deletePeticionsServei(Servei)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            deletePeticionsServei = False
        End Try
    End Function
    Function recursDisponible(ByVal Recurs As Integer, ByVal Data As Date, ByVal Hora As TimeSpan) As DataTable Implements IXPAServer.recursDisponible
        Try
            Dim _recurs As New DataBase.TaulaReservaRecurs
            recursDisponible = _recurs.recursDisponible(Recurs, Data, Hora)
        Catch ex As Exception
            LogManager.LogManager.escriuLogException(ex)
            recursDisponible = Nothing
        End Try
    End Function
End Class

